﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using C1.WPF.DataGrid;

namespace WpfDataGridGroupedSummary
{
    /// <summary>
    /// Interaction logic for Window1.xaml
    /// </summary>
    public partial class Window1 : Window
    {
        public Window1()
        {
            InitializeComponent();

            grid.ItemsSource = GetProducts();
            Loaded += new RoutedEventHandler(GroupSummaryPage_Loaded);
        }

        void GroupSummaryPage_Loaded(object sender, RoutedEventArgs e)
        {
            ////cmbColumns.ItemsSource = grid.Columns;
            //foreach (var column in grid.Columns)
            //{
            //    if (column.GroupState.Direction != DataGridSortDirection.None)
            //    {
            //        //cmbColumns.SelectedItem = column;
            //        break;
            //    }
            //}
            //cmbColumns.SelectionChanged += (s, args) =>
            //{
            //    grid.GroupBy(args.AddedItems[0] as DataGridColumn);
            //};
        }

        #region ** data

        public static IEnumerable<Product> GetProducts()
        {
            IEnumerable<Product> products = Data.GetProducts((product) => !string.IsNullOrEmpty(product.Element("ProductModelID").Value));
            foreach (var product in products)
            {
                product.ExpirationDate = GetDate(product.StandardCost);
                product.Available = GetAvailable(product.Name);
            }
            return products;
        }

        private static bool? GetAvailable(string seed)
        {
            return (seed.Length % 3 == 0 ? (bool?)true : (seed.Length % 3 == 1 ? (bool?)false : (bool?)null));
        }

        private static DateTime? GetDate(double seed)
        {
            return new DateTime(DateTime.Now.Ticks - ((long)seed * 10000000000));
        }

        #endregion

        private void grid_AutoGeneratingColumn(object sender, DataGridAutoGeneratingColumnEventArgs e)
        {
            //Common.HandleColumnAutoGeneration(e);
        }


        private void grid_AutoGeneratedColumns(object sender, EventArgs e)
        {
            grid.Columns["ImageUrl"].DisplayIndex = 0;
            grid.Columns["StandardCost"].DisplayIndex = 6;
            grid.GroupBy(grid.Columns["ExpirationDate"]);
        }

        private void grid_CreatingRow(object sender, DataGridCreatingRowEventArgs e)
        {
            if (e.Type == DataGridRowType.Group)
            {
                e.Row = new DataGridGroupWithSummaryRow();
            }
        }

        private void grid_LoadingRow(object sender, DataGridRowEventArgs e)
        {
            if (e.Row.Type == DataGridRowType.Group)
            {
                DataGridGroupWithSummaryRow groupRow = e.Row as DataGridGroupWithSummaryRow;
                groupRow.Summaries[grid.Columns["StandardCost"]] = new ComputeSUM();
                var summaryRow = new DataGridSummaryRow();
                summaryRow.Summaries[grid.Columns["StandardCost"]] = new ComputeSUM();
                summaryRow.Summaries[grid.Columns["ImageUrl"]] = new ComputeCOUNT();
                groupRow.Rows.BottomRows.Add(summaryRow);
            }
        }
    }

    public class Models : List<Model>
    {
        public Models()
        {
            foreach (var model in Data.GetModels())
            {
                Add(model);
            }
        }
    }
}
